#!/bin/bash
#
# rememberevent.sh
#
# source: vdr-plugin epgsearch
#
# add this lines to your epgsearchcmds.conf:
# folgende zeilen in die epgsearchcmds.conf eintragen:
#
# remember event              : /usr/local/bin/rememberevent.sh 0
# remember event (inc. switch): /usr/local/bin/rememberevent.sh 1
# Werbezapper                 : /usr/local/bin/rememberevent.sh 2
# show event list             : /usr/local/bin/rememberevent.sh -ls
# remove all events?          : /usr/local/bin/rememberevent.sh -rm

# CONFIG START
  ATD_SPOOL=/var/spool/atjobs

# default settings
  MINSBEFORE=1  # minutes before event for announcement
  ZAP=6
  COLUMNS=30    # columns for the epg entry
  FORMAT=UTC    # date format, eg.: UTC/MET
# CONFIG END

PATH=/usr/local/bin:$PATH

#set -x

# now in seconds since 1970-01-01
secs_now=`date +%s`

case $1 in
    -ls)
        grep -s ^'#[0-2][0-9]:[0-5][0-9]#' $ATD_SPOOL/* | sort -t. +1 | cut -d'#' -f3
        ;;
    -rm)
        find $ATD_SPOOL -exec grep -qs ^'#[0-2][0-9]:[0-5][0-9]#' \{} \; -exec rm -f \{} \;
        ;;
      *)
	if [ $1 -eq 2 ]; then
		secs_then=$((secs_now+$ZAP*60))
		sw_zap_time=`date -d "1970-01-01 UTC $secs_then seconds" +"%H:%M"`
		echo "svdrpsend.pl CHAN $5" | at $sw_zap_time
		exit
	fi
        switch_time=`date -d "1970-01-01 $FORMAT $3 seconds" +"%a.%d %H:%M"`
        entry="#${switch_time#* }#$(printf "%-10s%-0s\n" "${6:0:9}" "$switch_time ${2:0:$COLUMNS}")"
        secs=$(($3-$MINSBEFORE*60))
	
        if [ $secs -le $secs_now ]; then
            echo "svdrpsend.pl MESG '$2 already runs!' >/dev/null" | at now
        else
            if [ -z "$(find $ATD_SPOOL -exec grep -qs "^$entry$" \{} \; -exec rm -v \{} \;)" ]; then
                at $(date -d "1970-01-01 $FORMAT $secs seconds" +"%H:%M %m/%d/%Y") <<EOT
		svdrpsend.pl MESG '${switch_time#* }: $2' >/dev/null
                sleep $(($MINSBEFORE*60))s
		[ $1 -eq 0 ] && svdrpsend.pl MESG '$2 starts!' >/dev/null
		[ $1 -eq 1 ] && svdrpsend.pl CHAN $5 >/dev/null

$entry
EOT
	    fi
	fi
        ;;
esac

